//
//  date.h
//  Lecture3CPP
//
//  Created by presentations on 11/3/17.
//
//

#ifndef Lecture3CPP_date_h
#define Lecture3CPP_date_h

#include <iostream>
using namespace std;

class Date {
public:
    Date( int = 1, int = 1, int = 1900 ); // default constructor
    void print() const;  // print date in month/day/year format
    ~Date();                 // confirm destruction order
private:
    int month;    // 1-12
    int day;         // 1-31 based on month
    int year;        // any year
    int checkDay( int, int);  // utility function to test proper day for month and year
}; // end class Date (interface)


Date::Date( int mn, int dy, int yr )
{
    if ( mn > 0 && mn <= 12 )       // validate the month
        month = mn;
    else {
        month = 1;
        cout << "Month " << mn << " invalid. Set to month 1.\n";
    } // end else
    year = yr;                         // should validate yr
    day = checkDay( dy, mn );     // validate the day
    cout << "Date object constructor for date ";
    print();         // print with no arguments
    cout << endl;
} // end Date constructor


void Date::print() const  { cout << month << '/' << day << '/' << year; }
Date::~Date()       // Destructor: provided to confirm destruction order
{
    cout << "Date object destructor for date ";
    print();     cout << endl;
} // end Date destructor

int Date::checkDay( int testDay, int month)   // test for proper day value
{
    static const int daysPerMonth[13] =
    {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
    if ( testDay > 0 && testDay <= daysPerMonth[month])
        return testDay;
    if  ( month == 2 && testDay == 29 &&  // February: Check for leap year
         ( year % 400 == 0 ||
          ( year % 4 == 0 && year % 100 != 0 ) ) )
        return testDay;
    cout << "Day " << testDay << " invalid. Set to day 1.\n";
    return 1;  // leave object in consistent state if bad value
} // end function checkDay
// end class Date (implementation)


#endif
