//
//  employee.h
//  Lecture3CPP
//
//  Created by presentations on 11/3/17.
//
//

#ifndef Lecture3CPP_employee_h
#define Lecture3CPP_employee_h
#include <iostream>
#include <cstring>
#include "date.h"

class Employee {
public:
    Employee( char *, char *, int, int, int, int, int, int );
    void print() const;
    ~Employee();  // provided to confirm destruction order
private:
    char firstName[ 25 ];      // fixed size up to 25 characters
    char lastName[ 25 ];
    const Date birthDate;
    const Date hireDate;
    
}; // end class Employee (interface)

Employee::Employee( char *fname, char *lname, int bmonth, int bday, int byear,
                   int hmonth, int hday, int hyear )
: birthDate( bmonth, bday, byear ),  hireDate( hmonth, hday, hyear )
{
    int length = strlen( fname );               // copy fname
    length = ( length < 25 ? length : 24 );//                into firstName
    strncpy( firstName, fname, length );  //                                  and be sure
    firstName[ length ] = '\0';                   //                                                   that it fits
    length = strlen( lname );                     // copy lname
    length = ( length < 25 ? length : 24 );//               into lastName
    strncpy( lastName, lname, length );   //                                and be sure
    lastName[ length ] = '\0';                    //                                                    that it fits
    cout << "Employee object constructor: " << firstName << ' ' << lastName << endl;
} // end Employee constructor

void Employee::print() const
{
    cout << lastName << ", " << firstName << "\nHired: ";
    hireDate.print();
    cout << "  Birth date: ";
    birthDate.print();
    cout << endl;
} //end function print

// Destructor: provided to confirm destruction order
Employee::~Employee()
{
    cout << "Employee object destructor: "
    << lastName << ", " << firstName << endl;
} // end Employee destructor


#endif
