//
//  test4.cpp
//  Lecture3CPP
//
//  Created by presentations on 11/1/17.
//
//

#include <iostream>
using namespace std;

class Time {
public:
    Time( int = 0, int = 0, int = 0 );    // constructor
    void setTime(int h, int m, int s);  //  set functions
    void setHour( int );
    void setMinute( int );
    void setSecond( int );
    int getHour();              // get functions
    int getMinute();
    int getSecond();
    void printMilitary();    // output functions
    void printStandard();
private:
    int hour;                // 0 - 23
    int minute;            // 0 - 59
    int second;            // 0 – 59
};

    
Time::Time( int hr, int min, int sec )
{
    setTime( hr, min, sec );
}

void Time::setTime(int h, int m, int s )
{
    setHour( h );
    setMinute( m );
    setSecond( s );
} // end function setTime
    
void Time::setHour(int h)
{
    hour = ( h >= 0 && h < 24 ) ? h : 0;
}

void Time::setMinute(int m)
{
    minute = ( m >= 0 && m < 60 ) ? m : 0;
}

void Time::setSecond(int s)
{
    second = ( s >= 0 && s < 60 ) ? s : 0;
}
    
int Time::getHour()    { return hour; }
int Time::getMinute() { return minute; }
int Time::getSecond() { return second; }

void Time::printMilitary()
{
    cout << ( hour < 10 ? "0" : "" ) << hour << ":"
    << ( minute < 10 ? "0" : "" ) << minute;
} // end function printMilitary


void Time::printStandard()
{
    cout << ( ( hour == 0 || hour == 12 ) ? 12 : hour % 12 )
    << ":" << ( minute < 10 ? "0" : "" ) << minute
    << ":" << ( second < 10 ? "0" : "" ) << second
    << ( hour < 12 ? " AM" : " PM" );
} // end function printStandard

void incrementMinutes(Time &tt, const int count)
{
    for ( int i = 0; i < count; i++ ) {
        tt.setMinute( ( tt.getMinute() + 1 ) % 60);
        if ( tt.getMinute() == 0 )
            tt.setHour( ( tt.getHour() + 1 ) % 24);
    }
} // end function incrementMinutes


int main()
{
    Time t;
    t.setHour( 17 );
    t.setMinute( 58 );
    t.setSecond( 25 );
    incrementMinutes( t, 3 );
    return 0;
} // end function main

