//
//  test6.cpp
//  Lecture3CPP
//
//  Created by presentations on 11/3/17.
//
//

#include <iostream>
using namespace std;

class Time {
public:
    Time( int = 0, int = 0, int = 0 );  // default constructor – can’t be declared as a const
    void setTime( int, int, int );    /* set functions  */
    void setHour( int );
    void setMinute( int );
    void setSecond( int );
    int getHour() const;                /* get functions (normally declared const)*/
    int getMinute() const;
    int getSecond() const;
    void printMilitary() const;      /* prints functions(normally declared  const) */
    void printStandard() const;    // should be const
private:
    int hour;
    int minute;
    int second;
}; // end class Time (interface)

Time::Time( int hr, int min, int sec )     { setTime( hr, min, sec ); }

void Time::setTime(int h, int m, int s )   // non-const
{
    setHour( h );
    setMinute( m );
    setSecond( s );
} // end function setTime

void Time::setHour( int h ){ hour = ( h >= 0 && h < 24 ) ? h : 0; }
void Time::setMinute( int m ){ minute = (m>=0 && m<60 ) ? m : 0;}
void Time::setSecond( int s ) { second = ( s >= 0 && s < 60 ) ? s : 0;}
int Time::getHour() const { return hour; }
int Time::getMinute() const { return minute; }
int Time::getSecond() const { return second; }

// Display military format time: HH:MM
void Time::printMilitary() const
{
    cout << ( hour < 10 ? "0" : "" ) << hour << ":"
    << ( minute < 10 ? "0" : "" ) << minute;
} // end function printMilitary

// Display standard format time: HH:MM:SS AM (or PM)
void Time::printStandard()  const// should be const
{
    cout << ( ( hour == 12 ) ? 12 : hour % 12 ) << ":"
    << ( minute < 10 ? "0" : "" ) << minute << ":"
    << ( second < 10 ? "0" : "" ) << second
    << ( hour < 12 ? " AM" : " PM" );
} // end function printStandard
// end class Time (implementation)

int main()
{
    Time wakeUp( 6, 45, 0 );    //non-const object
    const Time noon( 12, 0, 0 );//const object calls non-const constructor
    // MEMBER FUNCTION   OBJECT
    wakeUp.setHour( 18 );  //  non-const                  _________
    noon.setHour( 12 );       //  non-const                  const*
    wakeUp.getHour();       //  const                          _________
    noon.getMinute();         //  const                          const
    noon.printMilitary();     //  const                          const
    noon.printStandard();    //  non-const                   const*
    return 0;
} // end function main
//Depending on the compiler, an error or warning message is issued.
